<script setup lang="ts">
import { useMostOrderViewStore } from '@/stores/MostOrderView'
import {
  Chart as ChartJS,
  Title,
  Tooltip,
  Legend,
  BarElement,
  CategoryScale,
  LinearScale
} from 'chart.js'
import { onMounted, ref } from 'vue'
import { Bar } from 'vue-chartjs'

const mostOrderedStore = useMostOrderViewStore()
ChartJS.register(Title, Tooltip, Legend, BarElement, CategoryScale, LinearScale)

const chartData = ref({
  labels: [],
  datasets: [{ label: 'Data One', backgroundColor: '#f87979', data: [] }]
})

const chartOptions = { responsive: true }

function gencolor(num: number) {
  const colors = []

  for (let i = 0; i < num; i++) {
    const randomColor = '#' + Math.floor(Math.random() * 16777215).toString(16)
    colors.push(randomColor)
  }
  return colors
}

async function getView() {
  const labels = mostOrderedStore.mostOrders.map((item: any) => {
    return item.name
  })
  const data = mostOrderedStore.mostOrders.map((item: any) => {
    return item.countAppear
  })

  const colors = gencolor(labels.length)
  console.log(labels, data)
  chartData.value = {
    labels: labels,
    datasets: [
      {
        label: 'Data One',
        backgroundColor: colors,
        data: data
      }
    ]
  }
}

onMounted(async () => {
  await mostOrderedStore.getMostOrders()
  await getView()
})
</script>

<template>
  <v-card
    style="background-color: aliceblue"
    text="กราฟนี้แสดง Menu ที่ Member ที่มี ยอดซื้อมากกว่าค่าเฉลี่ย ที่ บ่อย ที่สุด และไม่ใช้ Promotion Discount"
  >
    <bar :data="chartData" :options="chartOptions" />
  </v-card>
</template>
